// SynDrive.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "SynDrive.h"
#include "SerialPorts.h"

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
    case WM_INITDIALOG:
        return TRUE;

    case WM_COMMAND:
      if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
      {
        EndDialog(hDlg, LOWORD(wParam));
        return TRUE;
      }
      break;
  }
    return FALSE;
}

LRESULT CALLBACK ComSet(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
    case WM_INITDIALOG:
        return TRUE;

    case WM_COMMAND:
      if (LOWORD(wParam) == IDCANCEL) 
      {
        EndDialog(hDlg, LOWORD(wParam));
        return TRUE;
      }
      if (LOWORD(wParam) == IDSETCOM) 
      {
        EndDialog(hDlg, LOWORD(wParam));
		tInfo->eDtr=DTR_DISABLE;
		tInfo->eRts=RTS_DISABLE;
		//ser_OpenComPort(tInfo);	//ffnet den Comport
		return TRUE;
      }
      if (LOWORD(wParam) == IDD_COM1) 
        tInfo->ePort=COMPORT1;
      if (LOWORD(wParam) == IDD_COM2) 
        tInfo->ePort=COMPORT2;
      if (LOWORD(wParam) == IDD_COM3) 
        tInfo->ePort=COMPORT3;
      if (LOWORD(wParam) == IDD_COM4) 
        tInfo->ePort=COMPORT4;
      if (LOWORD(wParam) == IDD_COM5) 
        tInfo->ePort=COMPORT5;
      if (LOWORD(wParam) == IDD_COM6) 
        tInfo->ePort=COMPORT6;
      if (LOWORD(wParam) == IDD_COM7) 
        tInfo->ePort=COMPORT7;
      if (LOWORD(wParam) == IDD_COM8) 
        tInfo->ePort=COMPORT8;
      if (LOWORD(wParam) == IDD_COM9)
        tInfo->ePort=COMPORT9;
      if (LOWORD(wParam) == IDD_BAUD600) 
        tInfo->eBaud =BR600;
      if (LOWORD(wParam) == IDD_BAUD1200) 
        tInfo->eBaud=BR1200;
      if (LOWORD(wParam) == IDD_BAUD2400) 
        tInfo->eBaud=BR2400;
      if (LOWORD(wParam) == IDD_BAUD4800) 
        tInfo->eBaud=BR4800;
      if (LOWORD(wParam) == IDD_BAUD9600) 
        tInfo->eBaud=BR9600;
      if (LOWORD(wParam) == IDD_BAUD14400) 
        tInfo->eBaud=BR14400;
      if (LOWORD(wParam) == IDD_BAUD19200) 
        tInfo->eBaud=BR19200;
      if (LOWORD(wParam) == IDD_BAUD28800) 
        tInfo->eBaud=BR28800;
      if (LOWORD(wParam) == IDD_BAUD38400) 
        tInfo->eBaud=BR38400;
      if (LOWORD(wParam) == IDD_BAUD56000) 
        tInfo->eBaud=BR56000;
      if (LOWORD(wParam) == IDD_BAUD57600) 
        tInfo->eBaud=BR57600;
      if (LOWORD(wParam) == IDD_BAUD115200) 
        tInfo->eBaud=BR115200;
      if (LOWORD(wParam) == IDD_BAUD128000) 
        tInfo->eBaud=BR128000;
      if (LOWORD(wParam) == IDD_BAUD256000) 
        tInfo->eBaud=BR256000;
      if (LOWORD(wParam) == IDD_DATABITS5) 
		tInfo->eLenght=LEN_FIVE;
      if (LOWORD(wParam) == IDD_DATABITS6) 
		tInfo->eLenght=LEN_SIX;
      if (LOWORD(wParam) == IDD_DATABITS7) 
        tInfo->eLenght=LEN_SEVEN;
      if (LOWORD(wParam) == IDD_DATABITS8) 
        tInfo->eLenght=LEN_EIGHT;
      if (LOWORD(wParam) == IDD_DATABITS9) 
        tInfo->eLenght=LEN_NINE;
      if (LOWORD(wParam) == IDD_PARITYNONE) 
		tInfo->eParity=PAR_NOONE;
      if (LOWORD(wParam) == IDD_PARITYODD) 
        tInfo->eParity=PAR_ODD;
      if (LOWORD(wParam) == IDD_PARITYEVEN) 
        tInfo->eParity=PAR_EVEN;
      if (LOWORD(wParam) == IDD_PARITYMARK) 
        tInfo->eParity=PAR_SPACE;
      if (LOWORD(wParam) == IDD_STOPBITS1) 
        tInfo->eStop=STOP_ONE;
      if (LOWORD(wParam) == IDD_STOPBITS1_5) 
        tInfo->eStop=STOP_ONEPOINTFIVE;
      if (LOWORD(wParam) == IDD_STOPBITS2) 
        tInfo->eStop=STOP_TWO;
        //
      break;
  }
    return FALSE;
}

HINSTANCE g_instance;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  // Get the plot object that was saved when the window was created.
  CPlot *pThis = (CPlot *) GetWindowLong(hWnd, GWL_USERDATA);

  switch (message) 
  {
    case WM_COMMAND:
      {
        int wmId    = LOWORD(wParam); 
        int wmEvent = HIWORD(wParam); 
        // Parse the menu selections:
        switch (wmId)
        {
          case IDM_ABOUT:
            DialogBox(g_instance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
            break;
		  case IDM_MOREINFO:
            DialogBox(g_instance, (LPCTSTR)IDD_MOREINFOBOX, hWnd, (DLGPROC)About);
            break;
////////////////////////////////////////////////////////////////////////////////////////////to be implemented later....
		  case IDM_SETCOM:
            DialogBox(g_instance, (LPCTSTR)IDD_SETCOM, hWnd, (DLGPROC)ComSet);
			break;
///////////////////////////////////////////////////////////////////////////////////////////////
          case IDM_EXIT:
            DestroyWindow(hWnd);
            break;
          default:
            return DefWindowProc(hWnd, message, wParam, lParam);
        }
      }
      break;
    case WM_CREATE:
      {
        // Save away the clock object passed to CreateWindow.
        CREATESTRUCT *pCreate = (CREATESTRUCT *) lParam;  
        SetWindowLong(hWnd, GWL_USERDATA, 
          (long) pCreate->lpCreateParams);

        pThis = (CPlot *) pCreate->lpCreateParams;
      }

      // If plot initialization fails, exit.
      if (!pThis->OnCreate(hWnd))
        DestroyWindow(hWnd);
      // Register for timer messages once a second.
      break;
    case WM_PAINT:
      {
        PAINTSTRUCT ps;
        HDC hdc;

        hdc = BeginPaint(hWnd, &ps);
        pThis->OnPaint(hdc);
		//hier beginnt mein Programmteil!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		//DLL_IM_EXPORT bool ser_WriteString( HANDLE         hPort, 
        //                                       char           *cData, 
        //                                       unsigned long  ulLenght );
		//heir endet mein Programmteil!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        EndPaint(hWnd, &ps);
      }
      break;
    case WM_DESTROY:
      PostQuitMessage(0);
      break;
    default:
      return DefWindowProc(hWnd, message, wParam, lParam);
  }
  return 0;
}

ATOM RegisterWindowClass(HINSTANCE hInstance)
{
  WNDCLASSEX wcex;

  wcex.cbSize = sizeof(WNDCLASSEX); 

  wcex.style      = CS_HREDRAW | CS_VREDRAW;
  wcex.lpfnWndProc  = (WNDPROC)WndProc;
  wcex.cbClsExtra   = 0;
  wcex.cbWndExtra   = 0;
  wcex.hInstance    = hInstance;
  wcex.hIcon      = LoadIcon(hInstance, (LPCTSTR)IDI_SynDrive);
  wcex.hCursor    = LoadCursor(0, IDC_ARROW);
  wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
  wcex.lpszMenuName = (LPCSTR)IDC_SynDrive;
  wcex.lpszClassName  = "SynDrive";
  wcex.hIconSm    = LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

  return RegisterClassEx(&wcex);
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  // Create the plot object.
  CPlot plot(hInstance);

  // Initialize global stuff
  RegisterWindowClass(hInstance);
  g_instance = hInstance;

  TCHAR szTitle[MAX_PATH];
  LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_PATH);

  HWND hWnd = CreateWindow("SynDrive", szTitle, WS_OVERLAPPEDWINDOW,
     CW_USEDEFAULT, CW_USEDEFAULT, 400, 300, 0, 0, hInstance, &plot);

  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  HACCEL hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SynDrive);

  // Main message loop:
  MSG msg;
  while (GetMessage(&msg, 0, 0, 0)) 
  {
    if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }

  return msg.wParam;
}
